import { AxiosFetchRequestConfig } from "./fetch.types";
export declare function isBrowser(): boolean;
/**
 * more resilient alternative to instanceof when the object is not native and compiled to es5
 * @param kind - string representation of the object kind
 * @returns - a function that checks if the object is of the given kind
 */
export declare const isKindOf: (kind: string) => (data: any) => boolean;
export declare const isFormData: (data: any) => boolean;
export declare const isBlob: (data: any) => boolean;
export declare const isFile: (data: any) => boolean;
export declare function getSearchParams(config: AxiosFetchRequestConfig<any>): string | undefined;
export declare function getFullURL(config: AxiosFetchRequestConfig<any>): string | undefined;
export declare function findCookieByName(name: string): string | undefined;
export declare function combineURLParams(url: string, searchParams?: string): string;
